import QtQuick 1.0
import "Utils.js" as Utils

Item {
    property string normalStrip
    property string rollingStrip
    property int currentNumber: Utils.randomNumber(normal_frames_count)
    property int currentFrame: Utils.randomNumber(normal_frames_count)
    property int currentMode: mode_normal

    property int deltaX: 0
    property int deltaY: 0

    property int mode_normal: 0
    property int mode_rolling: 1

    property int normal_frames_count: 6
    property int rolling_frames_count: 12
    //onCurrentNumberChanged: console.log(currentNumber)

    function roll()
    {
        if (currentMode == mode_rolling)
            return;
        var delta = 9;
        setDeltaX((Utils.randomNumber(2)===0?-1:1)*(Utils.randomNumber(delta)+delta));
        setDeltaY((Utils.randomNumber(2)===0?-1:1)*(Utils.randomNumber(delta)+delta));
        currentMode = mode_rolling;
        randNumber();
        animateTimer.start();
    }

    function getX() {return x;}
    function getY() {return y;}
    function getWidth() {return width;}
    function getHeight() {return height;}

    function setX(a) {x = a;}
    function setY(a) {y = a;}

    function setDeltaX(d)
    {
        deltaX = d;
    }
    function setDeltaY(d)
    {
        deltaY = d;
    }

    function getDeltaX()
    {
        return deltaX;
    }
    function getDeltaY()
    {
        return deltaY;
    }

    function randNumber()
    {
        currentNumber = Utils.randomNumber(normal_frames_count);
        //currentNormalImage = Image.createImage(normalStrip, currentNumber*normalStrip.getWidth()/NORMAL_FRAMES_COUNT, 0, normalStrip.getWidth()/NORMAL_FRAMES_COUNT, normalStrip.getHeight(), Sprite.TRANS_NONE);
        //console.log(x+" "+y + " " + currentNumber);
    }

    function move()
    {
        if (currentMode == mode_normal)
            return;
        x += deltaX;
        y += deltaY;
    }


    function getRollingFrameWidth()
    {
        return width;
        //return rollingStrip.getWidth()/rolling_frames_count;
    }
    function getRollingFrameHeight()
    {
        return height;
    }

    width: currentMode==mode_normal?frame.width/6:frame.width/12
    height: frame.height
    transform: Translate { y: -height/2; x: -width/2 }
    clip: true
    id: dice
    Image {
        id: frame
        //source: ""
        //anchors.fill: parent
        source: currentMode==mode_normal?normalStrip:rollingStrip
        x: -parent.width*(currentMode==mode_normal?currentNumber:currentFrame)
        //onXChanged: console.log(x)

    }

    Timer {
        id: animateTimer
        interval: 50; running: false; repeat: true
        onTriggered: {
            currentFrame++;
            currentFrame %= rolling_frames_count;
        }

    }

//    RotationAnimation {
//        running: currentMode == mode_rolling
//        target: dice
//        property: "currentFrame" // Suppress a warning
//        from: 0
//        to: 360
//        direction: RotationAnimation.Clockwise
//        duration: 1000
//        loops: Animation.Infinite
//    }
    //onXChanged: console.log(x+" "+y + " " + currentNumber);
    //onYChanged: console.log(x+" "+y + " " + currentNumber);
}
